"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var HttpSharedContext_1;
Object.defineProperty(exports, "__esModule", { value: true });
"use strict";
const dependency_injection_1 = require("@typemon/dependency-injection");
const check_1 = require("@typemon/check");
//
//
//
let HttpSharedContext = HttpSharedContext_1 = class HttpSharedContext {
    constructor() {
        this.map = new Map();
    }
    has(key) {
        const has = this.map.has(key);
        return has;
    }
    hasNot(key) {
        const has = this.has(key);
        const hasNot = check_1.Check.isFalse(has);
        return hasNot;
    }
    get(key) {
        if (this.hasNot(key)) {
            throw new Error(`Key '${key}' does not exist.`);
        }
        const value = this.map.get(key);
        return value;
    }
    set(key, value) {
        this.map.set(key, value);
    }
    delete(key) {
        this.map.delete(key);
    }
};
HttpSharedContext.PROVIDER = {
    identifier: HttpSharedContext_1,
    useClass: HttpSharedContext_1,
    lifetime: dependency_injection_1.Lifetime.Singleton
};
HttpSharedContext = HttpSharedContext_1 = __decorate([
    dependency_injection_1.Injectable(),
    __metadata("design:paramtypes", [])
], HttpSharedContext);
exports.HttpSharedContext = HttpSharedContext;
