import { Constructor } from '@typemon/dependency-injection';
import { GlobalOptions } from './global-options';
import { Event, Context } from './parameters';
export declare class Runner {
    private readonly target;
    private readonly propertyKey;
    private readonly globalOptions;
    private readonly targetHandle;
    private readonly controllerMetadata;
    private readonly handlerMetadata;
    private readonly useAPIGateway;
    private done;
    constructor(target: Constructor, propertyKey: string, globalOptions: GlobalOptions);
    private createRootContainer;
    private createHandlerContainer;
    private executeMiddleware;
    private executeMiddlewares;
    private executeHandler;
    run(event: Event, context: Context): Promise<unknown>;
}
