import { Provider } from '@typemon/dependency-injection';
import { Middleware } from './middleware';
export declare function Controller(options?: Controller.Options): ClassDecorator;
export declare namespace Controller {
    interface Options {
        /**
         * @default true
         */
        readonly useAPIGateway?: boolean;
        readonly providers?: ReadonlyArray<Provider>;
        readonly middlewares?: ReadonlyArray<Middleware.Constructor | Middleware.WithProviders>;
    }
    interface Metadata {
        readonly options: Options;
    }
}
