import { Constructor } from '@typemon/dependency-injection';
import { GlobalOptions } from './global-options';
import { Event, Context } from './parameters';
export declare type Lambda = (event: Event, context: Context) => Promise<unknown>;
export declare type Lambdas = Readonly<Record<string, Lambda>>;
export declare function lambdify(target: Constructor): Lambdas;
export declare namespace lambdify {
    function globally(options: GlobalOptions): void;
}
