export declare class HttpParameters {
    private readonly map;
    constructor(parameters?: Readonly<Record<string, string>>);
    has(key: string): boolean;
    hasNot(key: string): boolean;
    get(key: string): string;
    set(key: string, value: string): void;
    delete(key: string): void;
    deleteAll(keys?: Iterable<string>): void;
}
export interface ReadonlyHttpParameters {
    has(key: string): boolean;
    hasNot(key: string): boolean;
    get(key: string): string;
}
