"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const dependency_injection_1 = require("@typemon/dependency-injection");
//
//
//
var ParameterToken;
(function (ParameterToken) {
    ParameterToken.EVENT = dependency_injection_1.InjectionToken.create('Typemon.Lambdify.Parameters.Event');
    ParameterToken.CONTEXT = dependency_injection_1.InjectionToken.create('Typemon.Lambdify.Parameters.Context');
    ParameterToken.HEADERS = dependency_injection_1.InjectionToken.create('Typemon.Lambdify.Parameters.Headers');
    ParameterToken.HEADER = dependency_injection_1.InjectionToken.create('Typemon.Lambdify.Parameters.Header');
    ParameterToken.PATH_PARAMETERS = dependency_injection_1.InjectionToken.create('Typemon.Lambdify.Parameters.Path-Parameters');
    ParameterToken.PATH_PARAMETER = dependency_injection_1.InjectionToken.create('Typemon.Lambdify.Parameters.Path-Parameter');
    ParameterToken.QUERY_PARAMETERS = dependency_injection_1.InjectionToken.create('Typemon.Lambdify.Parameters.Query-Parameters');
    ParameterToken.QUERY_PARAMETER = dependency_injection_1.InjectionToken.create('Typemon.Lambdify.Parameters.Query-Parameter');
    ParameterToken.BODY = dependency_injection_1.InjectionToken.create('Typemon.Lambdify.Parameters.Body');
    ParameterToken.NEXT = dependency_injection_1.InjectionToken.create('Tyepmon.Lambdify.Parameters.Next');
    ParameterToken.RESPONSE_HEADERS = dependency_injection_1.InjectionToken.create('Tyepmon.Lambdify.Parameters.Response-Headers');
})(ParameterToken = exports.ParameterToken || (exports.ParameterToken = {}));
